C fort.3 becomes the new lmcn.in
C fort.4 is the summary file, not used by this program
        implicit double precision (a-h,o-z)
        parameter (maxstars=9999)
	character*1 stat(maxstars)
	character*1 sign
	character*80 inline,filein
	dimension ra(maxstars),dec(maxstars)
	character*20 name(maxstars)
	character*25 coords(maxstars)
	dimension irvec1(4),idvec1(4)
C
*  SECONDS TO RADIANS
      PARAMETER (S2R=0.72722052166430398D-4)
*  ARC SECONDS TO RADIANS
      PARAMETER (AS2R=0.48481368110953599D-5)
C
*  SECONDS TO RADIANS
      STOR(RH,RM,RS)=S2R*(60D0*(60D0*RH+RM)+RS)
*  ARC SECONDS TO RADIANS
      ASTOR(DD,DM,DS)=AS2R*(60D0*(60D0*DD+DM)+DS)
C initialize stat:
	rad40=60.*40.
	do i=1,9999
	stat(i)='N'
	end do
	
C This is the master file
	open(unit=1,file='lmc.in',status='old')
C Read in everything and convert to ra and dec
1	read(1,2,end=3) inline
2	format(a80)
	read(inline(1:4),*) ix
	if(ix.gt.maxstars) stop 'problemA'
	stat(ix)=inline(53:53)
	coords(ix)=inline(27:51)
	name(ix)=inline(6:25)
	read(inline(27:51),123) ihr,imin,sec,sign,ideg,iamin,asec
123	format(i2,1x,i2,1x,f6.3,1x,a1,i2,1x,i2,1x,f5.2)
	if(sign.eq.'-') then
	ideg=-ideg
	iamin=-iamin
	asec=-asec
	end if
	ra(ix)=stor(ihr,imin,sec)
	dec(ix)=astor(ideg,iamin,asec)
	write(6,124) ix,ra(ix),dec(ix),stat(ix)
124	format(i5,2f12.6,1x,a1)
	go to 1
3	write(6,4) 
4	format('Done loading master list in')
	close(unit=1)
C This is the stuff we've been doing
	open(unit=1,file='listofhydra',status='old')
5	read(1,2,end=11) filein
	alast=lnblnk(filein)
	write(6,2) filein
	open(unit=2,file=filein(1:alast),status='old')
199	read(2,2,end=6) inline
	write(6,2) inline
	if (inline(53:63).eq.'O  STATUS= ') then
	read(inline(1:4),*) ix
	stat(ix)='E'
	write(6,*) ix,stat(ix)
	end if
	go to 199
6	close(unit=2)
	go to 5
11	close(unit=1)
C OK, we have now updated all of the stat...
C Call newcent!
	call newcent(ra,dec,maxstars,stat,rac,decc)
	if(rac.eq.0.) stop 'no good center'
C start writing things out:
	call dr2tf(3,rac,sign,irvec1)
	call dr2af(2,decc,sign,idvec1)
	fract=irvec1(2)/60.
	ifract=fract*100.+0.5
	open(unit=1,file='lmchead',status='old')
12	read(1,2,end=13) inline
        last = lnblnk(inline)
	if(inline(1:3).eq.'SID') then
	write(3,223) irvec1(1),ifract
223	format('SIDEREAL TIME: ',i2,'.',i2.2)
	else
	write(3,222) inline(1:last)
	end if
 222    format(a)
	go to 12
13	close(unit=1)
	write(3,14) irvec1,sign,idvec1
14	format('0001 Center',15x,i2.2,1x,i2.2,1x,i2.2,'.',i3.3,
     &  1x,a1,i2.2,1x,i2.2,1x,i2.2,'.',i2.2,1x,'C')
C now identify all of the objects, skies, and fops within 0.5 deg of this:
	do i=1,maxstars
	if(stat(i).ne.'N') then
	write(4,16) i,name(i),coords(i),stat(i)
	call apa(rac,decc,ra(i),dec(i),sep,pa)
	dist=sep/as2r
	if(dist.lt.rad40) then
	write(3,16) i,name(i),coords(i),stat(i)
16	format(i4.4,1x,a20,1x,a25,1x,a1)
	end if
	end if
	end do
	stop
	end
	subroutine newcent(ra,dec,maxstars,stat,bestrac,bestdecc)
        implicit double precision (a-h,o-z)
        character*1 stat(*)
	character*1 sign
        dimension ra(*),dec(*)
	dimension irvec1(4),idvec1(4)
C
*  SECONDS TO RADIANS
      PARAMETER (S2R=0.72722052166430398D-4)
*  ARC SECONDS TO RADIANS
      PARAMETER (AS2R=0.48481368110953599D-5)
C
*  SECONDS TO RADIANS
      STOR(RH,RM,RS)=S2R*(60D0*(60D0*RH+RM)+RS)
*  ARC SECONDS TO RADIANS
      ASTOR(DD,DM,DS)=AS2R*(60D0*(60D0*DD+DM)+DS)

	
	rad=(60.*40.1)/2.
C for each center position
	ibest=0
	bestrac=0.
	bestdecc=0.
C now for each center....
	do 53 i=1,maxstars
	if(stat(i).eq.'N') go to 53
	rac=ra(i)
	decc=dec(i)
C first make sure there are at least 3 fops in the FOV
	ifops=0
	do 55 k=1,maxstars
	if(stat(k).ne.'F') go to 55
	call apa(rac,decc,ra(k),dec(k),sep,pa)
	dist=sep/as2r
	if(dist.lt.rad) ifops=ifops+1
55	continue
	if(ifops.lt.3) go to 53
	inum=0
	do 54 j=1,maxstars
	if(stat(j).ne.'O') go to 54
	call apa(rac,decc,ra(j),dec(j),sep,pa)
	dist=sep/as2r
	if(dist.lt.rad) inum=inum+1
54	continue
	if(inum.gt.ibest) then
	ibest=inum
	bestrac=rac
	bestdecc=decc
	end if
53	continue
        call dr2tf(3,bestrac,sign,irvec1)
        call dr2af(2,bestdecc,sign,idvec1)
	write(6,101) ibest
101	format('Maximum number of objects:',i9)
	write(6,102) irvec1,sign,idvec1
102	format('#   1 CenterN',14x,i2.2,1x,i2.2,1x,i2.2,'.',i3.3,
     &  1x,a1,i2.2,1x,i2.2,1x,i2.2,'.',i2.2,1x,'C')
	return
	end
        subroutine apa(rac,dcc,rao,dco,dist,pa)
c computes the distance (delt) and position (pa) along the
c sky FROM (rac,dec) to (rao,dco)
c written aug 14, 1987
C rewritten August 21, 1989, to do using "standard coords", rather
C than the old and peculiar (but possibly equivalent!) way
c plm
        implicit double precision (a-h,o-z)
        parameter (PI=3.141592653589793238462643)
C CONVERT TO PROPER COORDS
        CALL DS2TP(RAO,DCO,RAC,DCC,XI,ETA)
        pa=0.
        if(xi*eta.ne.0.)PA=DATAN2(XI,ETA)
        if(pa.le.0.) pa=pa+2.*pi
        DIST=DSQRT(XI**2+ETA**2)
        return
        end
        include 'astromsub.f'
